import string
import _log2vis

RTL, LTR = 0, 1

def log2vis(text, width=80, align=RTL, before=' ', after='\n'):
    """ Convert logical to visual, handling line breaks as well. """
    
    outtext = ""
    lines = []
    
    for log_line in string.split(text, '\n'):
        if len(log_line) and log_line[-1] == '\r': log_line = log_line[:-1]
        if len(log_line) > 8192: raise OverflowError, "Lines must be less than 8192 characters long."
        lines.append(_log2vis.log2vis(log_line))
    
    if align == RTL:
        # Align to right
        for line in lines:   
            while len(line) > width: # we need to divide
                # find first space after length
                fragment = string.split(line[-width:], ' ', 1)
                try:
                    fragment = fragment[1]
                except:
                    fragment = ""
                outtext = "%s%s%s%s" % (outtext, (before * (width - len(fragment) - 1) ), fragment, after)
                line = line[:-len(fragment)]

            outtext = "%s%s%s%s" % (outtext, (before * (width - len(line) - 1)), line, after)
    else:
        # Align to left
        for line in lines:
            if not line:
                outtext = outtext + after
                continue
            words = string.split(line)
            current = words.pop(0)
            for word in words:
                increment = 1 + len(word)
                if len(current) + increment > width:
                    outtext = "%s%s%s" % (outtext, current, after)
                    current = word
                else:
                    current = "%s %s" % (current, word)
            outtext = "%s%s%s" % (outtext, current, after)
            
    return outtext
